function gadget:GetInfo()
	return 
	{
		name = "Artillery Velocity Control",
		desc = "Allows Artillery to use different velocity settings.",
		author = "Argh",
		date = "June 3rd, 2008",
		license = "(C) Wolfe Games",
		layer = 1,
		enabled = true
	}
end

local CanControlArtyVelocity = {}

local CMD_CONTROL_ARTY_VELOCITY = 32614

if (gadgetHandler:IsSyncedCode()) then
-----------------------------------------------SYNCHED
----------------------------------------------------------------
------------------------------------------------------------------------

function gadget:Initialize()
	for ud,_ in pairs(UnitDefs) do
		if UnitDefs[ud].customParams.can_control_arty_velocity == 'yes' then
			table.insert(CanControlArtyVelocity,ud,1)
		end
	end
end

ControlArtyVelocity = {
		id=CMD_CONTROL_ARTY_VELOCITY,
		type=CMDTYPE.ICON,
		name="",
		onlyTexture=true,
		texture="&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/VELOCITY_MED.png",
		tooltip="Your unit's gun is firing at medium velocity.\r\nHint: Low decreases range, but increases accuracy.\r\nHigh increases range, but really decreases accuracy!\r\nMedium is all-purpose.",
		action="alter artillery's velocity"
		}
	

function gadget:UnitCreated(u, ud, team)
	if CanControlArtyVelocity[Spring.GetUnitDefID(u)] then
		Spring.InsertUnitCmdDesc(u, ControlArtyVelocity)
		Spring.CallCOBScript(u, "ArtyVelocitySwitcher", 0)
		Spring.CallCOBScript(u, "ArtyVelocitySwitcher", 0)
	end
end

function StandardArtyVelocity(u, ud, team)
	local cmdID = Spring.FindUnitCmdDesc(u, CMD_CONTROL_ARTY_VELOCITY)
	Spring.EditUnitCmdDesc(u, cmdID, {
		name="",
		onlyTexture=true,
		texture="&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/VELOCITY_MED.png",
		tooltip="Your unit's gun is firing at medium velocity.\r\nHint: Low decreases range, but increases accuracy.\r\nHigh increases range, but really decreases accuracy!\r\nMedium is all-purpose.",
		})
end
gadgetHandler:RegisterGlobal("StandardArtyVelocity", StandardArtyVelocity)

function LowArtyVelocity(u, ud, team)
	local cmdID = Spring.FindUnitCmdDesc(u, CMD_CONTROL_ARTY_VELOCITY)
	Spring.EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture="&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/VELOCITY_LOW.png",
			tooltip = "Your unit's gun is firing at a lower velocity.\r\nHint: Low decreases range, but increases accuracy.\r\nHigh increases range, but really decreases accuracy!\r\nMedium is all-purpose.",
			})
end
gadgetHandler:RegisterGlobal("LowArtyVelocity", LowArtyVelocity)

function HighArtyVelocity(u, ud, team)
	local cmdID = Spring.FindUnitCmdDesc(u, CMD_CONTROL_ARTY_VELOCITY)
	Spring.EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture="&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/VELOCITY_HIGH.png",
			tooltip = "Your unit's gun is firing at its maximum velocity.\r\nHint: Low decreases range, but increases accuracy.\r\nHigh increases range, but really decreases accuracy!\r\nMedium is all-purpose.",
			})
end
gadgetHandler:RegisterGlobal("HighArtyVelocity", HighArtyVelocity)

function gadget:CommandFallback(u, ud, team, cmd, param, opts)
	if cmd  == CMD_CONTROL_ARTY_VELOCITY then
		Spring.CallCOBScript(u, "ArtyVelocitySwitcher", 0)
	return true, true;
	end
	return false
end

------------------------------------------------------------------------
----------------------------------------------------------------
-----------------------------------------------END
end
