        function gadget:GetInfo()
	return {
		name = "AutoReclaim",
		desc = "Makes builders automatically reclaim Gaia Units that aren't gameplay devices.",
		author = "Argh",
		date = "August 14th, 2008",
		license = "(C) Wolfe Games, 2008",
		layer = 1,
		enabled = true,
	}
end

local CMD_RECLAIM = CMD.RECLAIM
local CMD_INSERT = CMD.INSERT
local CMD_OPT_SHIFT = CMD.OPT_SHIFT
local MAX_UNITS = Game.maxUnits
local GetSelectedUnits = Spring.GetSelectedUnits
local GetUnitDefID = Spring.GetUnitDefID
local GiveOrderToUnit = Spring.GiveOrderToUnit
local GetUnitsInSphere = Spring.GetUnitsInSphere
local GetFeaturesInRectangle = Spring.GetFeaturesInRectangle
local GetTeamUnits = Spring.GetTeamUnits

local DoNotAreaReclaim = {
	[UnitDefNames.ancientpower.id] = "ancientpower",
	[UnitDefNames.ancientmetal.id] = "ancientmetal",
}

--////////////////////////////////////////////////////////////////////  SAFE DELAYED COMMANDS
local delayedCalls = {}
function DelayedCall(fun)
	delayedCalls[#delayedCalls+1] = fun 
end

function gadget:GameFrame(f)
	for i=1,#delayedCalls do
		local fun = delayedCalls[i]
		fun()
	end
	delayedCalls = {}
end
--////////////////////////////////////////////////////////////////////

function gadget:AllowCommand(u, ud, team, cmd, param, opts)
	if cmd == CMD_RECLAIM then
	local x = param[1]
	local y = param[2]
	local z = param[3]
	local r = param[4]
	if r ~= 0 and r ~= nil then
		local reclaimList = GetUnitsInSphere(x,y,z,r,Spring.GetTeamUnits(Spring.GetGaiaTeamID()))
		if reclaimList[1] ~= nil then
			for _,target in ipairs (reclaimList) do
				if not DoNotAreaReclaim[GetUnitDefID(target)] then
					DelayedCall(function()
						GiveOrderToUnit(u, CMD_INSERT,{-1,CMD_RECLAIM,CMD_OPT_SHIFT, target},{"alt"})
					end)
				end
			end
		reclaimList = GetFeaturesInRectangle(x-r,z-r,x+r,z+r)
			if reclaimList[1] ~= nil then
				for _,target in ipairs (reclaimList) do
					DelayedCall(function()
						GiveOrderToUnit(u, CMD_INSERT,{-1,CMD_RECLAIM,CMD_OPT_SHIFT, target+MAX_UNITS},{"alt"})
					end)
				end
			end
		end
	else return CMD_RECLAIM end
	else return true end
	return false
end