function gadget:GetInfo()
	return {
		name = "CustomCommands.lua",
		desc = "Alters UI",
		author = "Argh",
		date = "April 6th, 2008",
		license = "Copyright (C) Wolfe Games, 2008",
		layer = 1,
		enabled = true,
		}
end

local Infantry = {}

local EngineeringTeam = {}

local MegaConstructor = {}

local GroundCombat = {}

local AirCombat = {}

local Factory = {}

local MobileBuilder = {}

local MobileRadar = {}

local Immobile_Combat = {}

local Immobile_NonCombat = {}

local AllUnits = {}

local Null = {}

local EditUnitCmdDesc = Spring.EditUnitCmdDesc
local FindUnitCmdDesc = Spring.FindUnitCmdDesc
local RemoveUnitCmdDesc = Spring.RemoveUnitCmdDesc

if (gadgetHandler:IsSyncedCode()) then
-----------------------------------------------SYNCHED
----------------------------------------------------------------
------------------------------------------------------------------------
function gadget:Initialize()
	for ud,_ in pairs(UnitDefs) do
		if UnitDefs[ud].customParams.unit_ui_category == 'engineeringteam' then
			table.insert(EngineeringTeam,ud,1)
			table.insert(MobileBuilder,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'megaconstructor' then
			table.insert(MegaConstructor,ud,1)
			table.insert(MobileBuilder,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'ground_combat' then
			table.insert(GroundCombat,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'air_combat' then
			table.insert(AirCombat,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'factory' then
			table.insert(Factory,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'mobile_builder' then
			table.insert(MobileBuilder,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'mobile_radar' then
			table.insert(MobileRadar,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'immobile_combat' then
			table.insert(Immobile_Combat,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'immobile_noncombat' then
			table.insert(Immobile_NonCombat,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'infantry' then
			table.insert(Infantry,ud,1)
			table.insert(GroundCombat,ud,1)
			table.insert(AllUnits,ud,1)
		end
		if UnitDefs[ud].customParams.unit_ui_category == 'null' then
			table.insert(Null,ud,1)
		end
		if UnitDefs[ud].customParams.dies_with_buildings == 'yes' then
			table.insert(Infantry,ud,1)
			table.insert(GroundCombat,ud,1)
			table.insert(AllUnits,ud,1)
		end
	end
end

function gadget:UnitCreated(u, ud, team)
-----------------------------------------------------BUTTON REMOVAL
	if Null[ud] then
		local cmdID
		for posCommand = 0,50,1 do
			cmdID = FindUnitCmdDesc(u, posCommand)
			if cmdID ~= nil then
				RemoveUnitCmdDesc(u, cmdID)
			end
			cmdID = FindUnitCmdDesc(u, CMD.REPEAT)
			if cmdID ~= nil then
				RemoveUnitCmdDesc(u, cmdID)
			end
		end			
	end

	if MegaConstructor[ud] then
		local cmdID
		
		cmdID = FindUnitCmdDesc(u, CMD.STOP)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end	
	
		cmdID = FindUnitCmdDesc(u, CMD.REPEAT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.FIGHT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.RESTORE)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end						
	end

	if EngineeringTeam[ud] then
		local cmdID
		cmdID = FindUnitCmdDesc(u, CMD.CAPTURE) -- Special Hack command, "replaces" Capture
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/HACK.png",
			tooltip = "Allows Engineering Teams to take control of Ancient relics.\r\nHint: if you use more than one Engineering team, it will happen faster.",
			})
		end
	end	

	if Infantry[ud] then
		local cmdID
		cmdID = FindUnitCmdDesc(u, CMD.CAPTURE) -- Special Capture command, "replaces" Capture
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/CAPTURE.png",
			tooltip = "This unit can capture buildings and go inside them when captured.\r\nHint: if you use more than one unit, it will happen faster.",
			})
		end
		cmdID = FindUnitCmdDesc(u, CMD.RESTORE)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
		cmdID = Spring.FindUnitCmdDesc(u, CMD.CLOAK)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end	
	end	
	
	if GroundCombat[ud] then
		cmdID = FindUnitCmdDesc(u, CMD.REPEAT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
	end
	
	if AirCombat[ud] then
		cmdID = FindUnitCmdDesc(u, CMD.REPEAT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
	end	
	
	if Factory[ud] then
		local cmdID
		
		cmdID = FindUnitCmdDesc(u, CMD.STOP)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end						
	end		

	if Immobile_Combat[ud] then
		--NOTHING HERE FOR NOW	
	end

	if Immobile_NonCombat[ud] then
		local cmdID	
	
		cmdID = FindUnitCmdDesc(u, CMD.REPEAT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.STOP)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.AISELECT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end		
	end

	if MobileBuilder[ud] then
		local cmdID	
	
		cmdID = FindUnitCmdDesc(u, CMD.REPEAT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.FIGHT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
	end
	
	if MobileRadar[ud] then
		local cmdID	
	
		cmdID = FindUnitCmdDesc(u, CMD.REPEAT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.FIGHT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end	
	end
--------------------------------------------------------------END BUTTON REMOVAL	
		
--------------------------------------------------------------BUTTON REPLACEMENT

-------------------------------------------------------------------------------------------------------------START MAIN
	if AllUnits[ud] then
		local cmdID
		
		cmdID = FindUnitCmdDesc(u, CMD.STOP)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/STOP.png",
			tooltip = "This unit can be stopped.\r\nClick this, to make the unit stop moving immediately.",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.MOVE)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/MOVE.png",
			tooltip = "This unit can move around.\r\nOr, if it's a factory, you can set up movement for units built by it.\r\nYou can set up multiple move waypoints by left-clicking and holding SHIFT.",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.PATROL)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/PATROL.png",
			tooltip = "This unit can patrol an area.\r\nOr, if it's a factory, you can set up a patrol for units built by it.\r\nYou can set up multiple patrol waypoints by left-clicking and holding SHIFT.",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.FIGHT)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/FIGHT.png",
			tooltip = "This unit can attack while moving to a new location.\r\nThis allows the Unit to attack enemies it sees, instead of moving past them.",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.ATTACK)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/ATTACK.png",
			tooltip = "This unit can attack enemies.\r\nRight-click on enemies to attack them, or left-click this button and left-click the ground to attack the ground.",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.AREA_ATTACK)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/AREA_ATTACK.png",
			tooltip = "This unit can attack an area at random.\r\nLeft-click and drag to select the area you want this unit to attack.",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.GUARD)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/GUARD.png",
			tooltip = "This unit can guard other units.\r\nBuilders guarding builders help each other build, including factories.\r\nCombat units can also guard each other.",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.AISELECT)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/AI_SELECT.png",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.REPAIR)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/REPAIR.png",
			tooltip = "This unit can repair other units.\r\nTo repair, simply right-click on the unit that is damaged.",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.FIRE_STATE)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/FIRE_STATE1.png",
			tooltip = "Fire States are Free, Return Fire, and Hold Fire.\r\nChanging the state will change the way your units attack enemies.",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.MOVE_STATE)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/MOVE_STATE0.png",
			tooltip = "Move states are Normal, Aggressive and Passive.\r\nAggressive and Passive change the distance this unit will chase the enemy.",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.LOAD_UNITS)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/LOAD_UNITS.png",
			tooltip = "This unit can transport other units.\r\nClick and drag to select an area containing units you wish to load.",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.UNLOAD_UNITS)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/UNLOAD_UNITS.png",
			tooltip = "This command allows you to unload your units from this transport.\r\nClick and drag to select where you'd like to unload your units.",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.ONOFF)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/ONOFF0.png",
			tooltip = "This unit may be turned on or off.\r\nTurning a unit off may save Power, in emergencies.",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.RECLAIM)-- Special hack, "Reclaim" becomes "Recycle"
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			name = "",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/RECLAIM.png",
		tooltip = "Recycle allows you to convert natural resources, such as junk, trash...\r\n...plants and even old buildings into usable sources of Materials and Power.",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.CLOAK)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			name = "",
			onlyTexture=true,			
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/CLOAK_STATE0.png",
			tooltip = "Cloaking hides your units from the enemy.\r\nIt usually costs some Power to maintain.",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.STOCKPILE)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/resistance_button_background02.tif",
			tooltip = "This unit can stockpile shots for use later.\r\nIt may take some time and resources before a new shot is complete.",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.RESTORE)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.REPEAT)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			name = "",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/REPEAT_STATE0.png",
			tooltip = "This unit can repeat a command or commands indefinitely.\r\nThis is very useful for factories, but has other uses.",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.TRAJECTORY)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/TRAJECTORY_STATE0.png",
			tooltip = "This unit can fire upwards, like a mortar, or forwards, like a cannon.\r\nTry switching states to attack in different ways.",
			})
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.RESURRECT)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end
		
		cmdID = FindUnitCmdDesc(u, CMD.AUTOREPAIRLEVEL)
		if cmdID ~= nil then
			RemoveUnitCmdDesc(u, cmdID)
		end

		cmdID = FindUnitCmdDesc(u, CMD.WAIT)
		if cmdID ~= nil then
		EditUnitCmdDesc(u, cmdID, {
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/WAIT.png",
			tooltip = "This unit can be paused.\r\n It will wait until given a direct command, or another Wait command.\r\nWait can be used to chain many units to a complex command.",
			})
		end
	end
-------------------------------------------------------------------------------------------------------------END MAIN						
end

--////////////////////////////////////////////////////////////////////
--------------------------------------------------------------------------------------------------------------REAL-TIME BUTTONS
function gadget:AllowCommand(u, ud, team, cmd, param, opts)
---------------------------------------------------------------------------------------MOBILE BUILDERS

	
---------------------------------------------------------------------------------------END MOBILE BUILDERS
---------------------------------------------------------------------------------------MOVE_STATE
	if cmd  == CMD.MOVE_STATE then
		local STATE = Spring.GetUnitStates(u)
		local moveState = STATE.movestate
		local cmdID = FindUnitCmdDesc(u, CMD.MOVE_STATE)
		if cmdID == nil then return CMD.MOVE_STATE end
		if  moveState == 0 then
		EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/MOVE_STATE0.png",
			})
		end
		if moveState == 1 then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/MOVE_STATE1.png",
			})
		end
		if moveState == 2 then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/MOVE_STATE2.png",
			})
		end
	return CMD.MOVE_STATE
	end
---------------------------------------------------------------------------------------END MOVE_STATE
---------------------------------------------------------------------------------------FIRE_STATE	
	if cmd  == CMD.FIRE_STATE then
		local STATE = Spring.GetUnitStates(u)
		local fireState = STATE.firestate
		local cmdID = FindUnitCmdDesc(u, CMD.FIRE_STATE)
		if cmdID == nil then return CMD.FIRE_STATE end
		if  fireState == 0 then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/FIRE_STATE0.png",
			})
		end
		if fireState == 1 then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/FIRE_STATE1.png",
			})
		end
		if fireState == 2 then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/FIRE_STATE2.png",
			})
		end
	return CMD.FIRE_STATE
	end
---------------------------------------------------------------------------------------END FIRE_STATE
---------------------------------------------------------------------------------------ONOFF	
	if cmd  == CMD.ONOFF then
		local STATE = Spring.GetUnitStates(u)
		local onOff = STATE.active
		local cmdID = FindUnitCmdDesc(u, CMD.ONOFF)
		if cmdID == nil then return CMD.ONOFF end
		if  onOff == false then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/ONOFF0.png",
			})
		end
		if onOff == true then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/ONOFF1.png",
			})
		end
	return CMD.ONOFF
	end
---------------------------------------------------------------------------------------END ONOFF
	if cmd  == CMD.REPEAT then
		local STATE = Spring.GetUnitStates(u)
		local onOff = STATE['repeat']
		local cmdID = FindUnitCmdDesc(u, CMD.REPEAT)
		if cmdID == nil then return CMD.REPEAT end
		if  onOff == true then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/REPEAT_STATE0.png",
			})
		end
		if onOff == false then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/REPEAT_STATE1.png",
			})
		end
	return CMD.REPEAT
	end
---------------------------------------------------------------------------------------END REPEAT
	if cmd  == CMD.CLOAK then
		local STATE = Spring.GetUnitStates(u)
		local onOff = STATE['cloak']
		local cmdID = FindUnitCmdDesc(u, CMD.CLOAK)
		if cmdID == nil then return CMD.CLOAK end
		if  onOff == true then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/CLOAK_STATE0.png",
			})
		end
		if onOff == false then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/CLOAK_STATE1.png",
			})
		end
	return CMD.CLOAK
	end
---------------------------------------------------------------------------------------END CLOAK
	if cmd  == CMD.TRAJECTORY then
		local STATE = Spring.GetUnitStates(u)
		local onOff = STATE['trajectory']
		local cmdID = FindUnitCmdDesc(u, CMD.TRAJECTORY)
		if cmdID == nil then return CMD.TRAJECTORY end
		if  onOff == true then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/TRAJECTORY_STATE0.png",
			})
		end
		if onOff == false then
			EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/TRAJECTORY_STATE1.png",
			})
		end
	return CMD.TRAJECTORY
	end
---------------------------------------------------------------------------------------END TRAJECTORY
	--[[if cmd  == CMD.ATTACK then
		if param[2] == nil then
			--Spring.Echo("attack",param[1],param[2],param[3])
			local isNeutral = Spring.GetUnitNeutral(param[1])
			
			if isNeutral then
				Spring.Echo("Neutral target")
				local x,_,z = Spring.GetUnitPosition(param[1])
				--Spring.SetUnitNeutral(param[1],false)
				Spring.SetUnitTarget(u,x,0,z)

			end
		end
	end]]
---------------------------------------------------------------------------------------END ATTACK
	return true
end

----------------------------------------------------------------
------------------------------------------------------------------------
else
------------------------------------------------------------------------
----------------------------------------------------------------
-----------------------------------------------UNSYNCHED
----------------------------------------------------------------
-----------------------------------------------END
----------------------------------------------------------------
end