function gadget:GetInfo()
	return {
		name = "Cloak FX",
		desc = "Special FX for cloakers.",
		author = "Argh",
		date = "March 5, 2009",
		license = "CC-PD, or the least-restrictive copyrights that exist in your country of residence.",
		layer = 1,
		enabled = true,
	}
end

local cloakTable = {}
local GetUnitPosition = Spring.GetUnitPosition
local SpawnCEG = Spring.SpawnCEG

if (gadgetHandler:IsSyncedCode()) then

function gadget:Initialize()
	for ud,_ in ipairs(UnitDefs) do  -- search all UnitDef entries
		if UnitDefs[ud].customParams.cloak_fx == "yes" then
			table.insert(cloakTable,ud,0)
		end
	end
end

function gadget:UnitCloaked(unitID, unitDefID, teamID)
	if cloakTable[unitDefID] then
		x,y,z = GetUnitPosition(unitID)
		SpawnCEG(UnitDefs[unitDefID].customParams.cloak_fx_type, x, y, z, 0, 1.0, 0,0,0)
	end
end

function gadget:UnitDecloaked(unitID, unitDefID, teamID)
	if cloakTable[unitDefID] then
		x,y,z = GetUnitPosition(unitID)
		SpawnCEG(UnitDefs[unitDefID].customParams.decloak_fx_type, x, y, z, 0, 1.0, 0,0,0)
	end
end

end