function gadget:GetInfo()
	return 
	{
		name = "Drop Mine",
		desc = "Allows Resistance BikeTanks to drop mines.",
		author = "Argh",
		date = "March 20th, 2008",
		license = "(C) Wolfe Games",
		layer = 1,
		enabled = true
	}
end

local CanDropMine = {
    [UnitDefNames.resistance_biketank.id] = "resistance_biketank",
}

local IsMine = {
    [UnitDefNames.resistance_landmine.id] = "resistance_landmine",
}

local CMD_DROP_MINE = 32609

if (gadgetHandler:IsSyncedCode()) then
-----------------------------------------------SYNCHED
----------------------------------------------------------------
------------------------------------------------------------------------
DropMine = {
		id=CMD_DROP_MINE,
		type=CMDTYPE.ICON,
		name="Drop Mine",
		texture="&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/transform.tif",
		tooltip="Allows the BikeTank to drop a powerful landmine.\r\nHint: you may only do this once per BikeTank.",
		action="drop mine",
		cursor='Mine'
		}

function DropMineCommand(u, ud, team)

	Spring.InsertUnitCmdDesc(u, DropMine)

end
gadgetHandler:RegisterGlobal("DropMineCommand", DropMineCommand)


function gadget:UnitCreated(u, ud, team)
	if IsMine[Spring.GetUnitDefID(u)] then
		local cmdID = Spring.FindUnitCmdDesc(u, CMD.CLOAK)
		Spring.RemoveUnitCmdDesc(u, cmdID)
		local cmdID = Spring.FindUnitCmdDesc(u, CMD.STOP)
		Spring.RemoveUnitCmdDesc(u, cmdID)
		local cmdID = Spring.FindUnitCmdDesc(u, CMD.FIRE_STATE)
		Spring.RemoveUnitCmdDesc(u, cmdID)
		local cmdID = Spring.FindUnitCmdDesc(u, CMD.REPEAT)
		Spring.RemoveUnitCmdDesc(u, cmdID)		
	end
end

--////////////////////////////////////////////////////////////////////  SAFE DELAYED FUNCTION
local delayedCalls = {}
function DelayedCall(fun)
	delayedCalls[#delayedCalls+1] = fun 
end

function gadget:GameFrame(f)
	for i=1,#delayedCalls do
		local fun = delayedCalls[i]
		fun()
	end
	delayedCalls = {}
end
--////////////////////////////////////////////////////////////////////

function gadget:CommandFallback(u, ud, team, cmd, param, opts)
	if cmd  == CMD_DROP_MINE then
		if CanDropMine[ud] then
			local x,y,z = Spring.GetUnitPosition(u)
			DelayedCall(function()
				Spring.CreateUnit("Resistance_Landmine", x,y,z, 0, team)
			end)
			Spring.RemoveUnitCmdDesc(u, DropMine)
			return true, true;
		end
	end
	return false
end

------------------------------------------------------------------------
----------------------------------------------------------------
-----------------------------------------------END
end