function gadget:GetInfo()
	return {
		name = "Infantry Capture",
		desc = "Allows Infantry to capture certain buildings.",
		author = "Argh",
		date = "December 2, 2008",
		license = "CC-PD, or the least-restrictive copyrights that exist in your country of residence.",
		layer = 1,
		enabled = true,
	}
end

local myID, Group
local GetUnitDefID = Spring.GetUnitDefID
local CMD_CAPTURE = CMD.CAPTURE
local GetSelectedUnits = Spring.GetSelectedUnits

local CanCapture = {}
local CannotCapture = {}

local CanBeCaptured = {}

if (gadgetHandler:IsSyncedCode()) then

function gadget:Initialize()
	for ud,_ in pairs(UnitDefs) do
		if UnitDefs[ud].customParams.unit_ui_category == 'infantry' then
			table.insert(CanCapture,ud,1)
		end
		if UnitDefs[ud].customParams.can_hack == 'yes' then
			table.insert(CannotCapture,ud,1)
		end
		if UnitDefs[ud].customParams.can_be_captured == 'yes' then
			table.insert(CanBeCaptured,ud,1)
		end
	end
end

function gadget:AllowCommand(u, ud, team, cmd, param, opts)
	if  cmd == CMD_CAPTURE then
		--Spring.Echo("Capture Attempt")

		if CannotCapture[ud] then
			if CanBeCaptured[GetUnitDefID(param[1])] then
				--Spring.Echo("Capture Correct")
				return false
			else
				--Spring.Echo("No Capture")
				return CMD_CAPTURE
			end
		end

		if CanCapture[ud] then
			--Spring.Echo("Capture Starting",param[1])
			if CanBeCaptured[GetUnitDefID(param[1])] then
				--Spring.Echo("Capture Correct")
				return CMD_CAPTURE
			else
				--Spring.Echo("No Capture")
				return false
			end
		end
	end
	return true
end

end