function gadget:GetInfo()
	return 
	{
		name = "IonLaserExplosion",
		desc = "Spawns a Unit that generates the IonLaser's primary effect.",
		author = "Argh",
		date = "March 20th, 2008",
		license = "GPL, v. 3 or later",
		layer = 1,
		enabled = true
	}
end





-------------------------------------------------------------- SYNC CODE
--------------------------------------------------------
------------------------------------------------
if (gadgetHandler:IsSyncedCode()) then

-------------------------------------------------------------- VARIABLE DECLARATIONS
--------------------------------------------------------
------------------------------------------------
local GaiaTeam = Spring.GetGaiaTeamID
local SetUnitNeutral = Spring.SetUnitNeutral
local SetUnitNoMinimap = Spring.SetUnitNoMinimap
local SetUnitNoSelect = Spring.SetUnitNoSelect
local SetUnitAlwaysVisible = Spring.SetUnitAlwaysVisible

------------------------------------------------
--------------------------------------------------------
-------------------------------------------------------------- END VARIABLE DECLARATIONS

local IonLaserWeaponID

for i=1,#WeaponDefs do
  if (string.find(WeaponDefs[i].description,"Ion Laser")) then
    IonLaserWeaponID = WeaponDefs[i].id
  end
end

if (IonLaserWeaponID) then
  Script.SetWatchWeapon(IonLaserWeaponID,true)
end

--////////////////////////////////////////////////////////////////////  SAFE DELAYED FUNCTION
local delayedCalls = {}
function DelayedCall(fun)
	delayedCalls[#delayedCalls+1] = fun 
end


function gadget:GameFrame(f)
	for i=1,#delayedCalls do
		local fun = delayedCalls[i]
		fun()
	end
	delayedCalls = {}
end
--////////////////////////////////////////////////////////////////////

function gadget:Explosion(weaponID, px, py, pz, ownerID)
	if(weaponID == IonLaserWeaponID) then
		DelayedCall(function()
			local newUnit = Spring.CreateUnit("AAFX_ExplodeSphere", px,py,pz,0, GaiaTeam())
			SetUnitNeutral(newUnit, true)
			SetUnitNoMinimap(newUnit,true)
			SetUnitNoSelect(newUnit,true)
			SetUnitAlwaysVisible(newUnit,true)
		end)
	return false end
end

------------------------------------------------
--------------------------------------------------------
-------------------------------------------------------------- END SYNC CODE
else
-------------------------------------------------------------- UNSYNCED CODE
--------------------------------------------------------
------------------------------------------------

-------------------------------------------------------------- VARIABLE DECLARATIONS
--------------------------------------------------------
------------------------------------------------
local ExplosionList = {
[UnitDefNames.aafx_explodesphere.id] = "aafx_explodesphere",
}

local GL_LEQUAL = GL.LEQUAL
local GL_GREATER = GL.GREATER
local GL_QUADS = GL.QUADS
local GL_TEXTURE_GEN_MODE = GL.TEXTURE_GEN_MODE
local GL_EYE_PLANE  = GL.EYE_PLANE
local GL_EYE_LINEAR = GL.EYE_LINEAR
local GL_T   = GL.T
local GL_S   = GL.S
local GL_ONE = GL.ONE
local GL_SRC_ALPHA           = GL.SRC_ALPHA
local GL_ONE_MINUS_SRC_ALPHA = GL.ONE_MINUS_SRC_ALPHA
local glColor         = gl.Color
local glDepthTest     = gl.DepthTest
local glTexture       = gl.Texture
local glAlphaTest = gl.AlphaTest
local glBlending      = gl.Blending
local glUnit          = gl.Unit
local glDepthTest     = gl.DepthTest
local GetVisibleUnits  = Spring.GetVisibleUnits
local GetUnitDefID = Spring.GetUnitDefID
local glPolygonOffset = gl.PolygonOffset
------------------------------------------------
--------------------------------------------------------
-------------------------------------------------------------- END VARIABLE DECLARATIONS

function gadget:DrawWorld()

	local cx,cy,cz = GetCameraPosition

	unitIDList = Spring.GetVisibleUnits(-1,10000,false)

	if unitIDList[1] == nil then 
		return false 
	else	
		    for _,unitID in ipairs(unitIDList) do
		    	id = Spring.GetUnitDefID(unitID) 
		    	if ExplosionList[id] then
				Spring.UnitRendering.SetUnitLuaDraw(unitID,true)
				gl.Scissor(true)
				glDepthTest(GL_LEQUAL)
				glAlphaTest(GL_GREATER,0)
			      	glBlending(GL_SRC_ALPHA,GL_ONE)
				glTexture("unittextures/AAFX_ExplodeSphere.tif")
				glColor(1.0,1.0,1.0,0.5)
			        	glUnit(unitID,true)
			        	glBlending(GL_SRC_ALPHA,GL_ONE)
			        	glPolygonOffset(-16, -16)
			        	glColor(1.0,0.5,0,0.5)
			        	glUnit(unitID,true)
			end																																																		
			end
	end
	--gl.Texture("")
	gl.DepthMask(true)
	gl.DepthTest(true)
	gl.Color(1,1,1,1.0)	
end
------------------------------------------------
--------------------------------------------------------
-------------------------------------------------------------- END UNSYNCED CODE
end


					