function gadget:GetInfo()
	return 
	{
		name = "MBT SpeedMod",
		desc = "Allows Resistance MBTs to speed up or slow down.",
		author = "Argh",
		date = "March 20th, 2008",
		license = "(C) Wolfe Games",
		layer = 1,
		enabled = true
	}
end

local MBTSpeedMod_able = {
    [UnitDefNames.resistance_mbt.id] = "resistance_mbt",
}
local Health, MaxHealth

local CMD_MBT_SPEEDMOD = 32611

if (gadgetHandler:IsSyncedCode()) then
-----------------------------------------------SYNCED
----------------------------------------------------------------
------------------------------------------------------------------------
MBTSpeedMod = {
		id=CMD_MBT_SPEEDMOD,
		type=CMDTYPE.ICON,
		name = "Speed Up!",
		texture="&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/transform.tif",
		tooltip = "Allows the MBT to move much faster.\r\nHint: when moving fast, it is more vulnerable to enemy fire.",
		}

function ReduceHealthMBT(u, ud, team)
	local cmdID = Spring.FindUnitCmdDesc(u, CMD_MBT_SPEEDMOD)
	Spring.EditUnitCmdDesc(u, cmdID, {
			name = "Slow Down",
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/transform.tif",
			tooltip = "Returns MBT to normal speed and armor values.\r\nHint: this is faster than raising up, use when close to the enemy.",
			})
	Health, MaxHealth = Spring.GetUnitHealth(u)
	--Spring.SetUnitHealth(u,Health / 4)
	Spring.SetUnitMaxHealth(u,MaxHealth / 4)
end
gadgetHandler:RegisterGlobal("ReduceHealthMBT", ReduceHealthMBT)

function IncreaseHealthMBT(u, ud, team)
	local cmdID = Spring.FindUnitCmdDesc(u, CMD_MBT_SPEEDMOD)
    Spring.EditUnitCmdDesc(u, cmdID, {
    		name = "Speed Up!",
			texture = "&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/transform.tif",
			tooltip = "Allows the MBT to move much faster.\r\nHint: when moving fast, it is more vulnerable to enemy fire.",
			})
	Health, MaxHealth = Spring.GetUnitHealth(u)
	Spring.SetUnitMaxHealth(u,MaxHealth * 4)
	Spring.SetUnitHealth(u,Health * 4)	
end
gadgetHandler:RegisterGlobal("IncreaseHealthMBT", IncreaseHealthMBT)


function gadget:UnitCreated(u, ud, team)
	if MBTSpeedMod_able[Spring.GetUnitDefID(u)] then
		Spring.InsertUnitCmdDesc(u, MBTSpeedMod)
	end
end

function gadget:CommandFallback(u, ud, team, cmd, param, opts)
	if cmd  == CMD_MBT_SPEEDMOD then
		if MBTSpeedMod_able[ud] then
			Spring.CallCOBScript(u, "Transform", 0)
			return true, true;
		end
	end
	return false
end
------------------------------------------------------------------------
----------------------------------------------------------------
-----------------------------------------------END
end