function gadget:GetInfo()
	return
	{
		name = "Maxim Artillery Deploy Gadget",
		desc = "Allows Resistance Maxim Artillery to deploy and get ready to fire.",
		author = "Argh",
		date = "March 20th, 2008",
		license = "(C) Wolfe Games",
		layer = 1,
		enabled = true
	}
end

local MaximArtyDeploy_able = {
    [UnitDefNames.maximartillery.id] = "maximartillery",
}

local Shielded = {
    [UnitDefNames.resistance_multitruck_pillbox_radar.id] = "resistance_multitruck_pillbox_radar",
}

local CMD_MAXIMARTY_DEPLOY = 32612

if (gadgetHandler:IsSyncedCode()) then
-----------------------------------------------SYNCED
----------------------------------------------------------------
------------------------------------------------------------------------
MaximArty_Deploy = {
		id=CMD_MAXIMARTY_DEPLOY,
		type=CMDTYPE.ICON,
			name="",
			onlyTexture=true,
			texture="&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/transform.tif",
			tooltip = "Deploys the Maxim Artillery, so that is can fire.\r\nHint: when deployed, the Maxim Artillery cannot move.",
			}

function DeployMaximArty(u, ud, team)
	local cmdID = Spring.FindUnitCmdDesc(u, CMD_MAXIMARTY_DEPLOY)
	Spring.EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture="&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/transform.tif",
			tooltip = "Deploys the Maxim Artillery, so that is can fire.\r\nHint: when deployed, the Maxim Artillery cannot move.",
			})
end
gadgetHandler:RegisterGlobal("DeployMaximArty", DeployMaximArty)

function DriveMaximArty(u, ud, team)
	local cmdID = Spring.FindUnitCmdDesc(u, CMD_MAXIMARTY_DEPLOY)
    Spring.EditUnitCmdDesc(u, cmdID, {
			name="",
			onlyTexture=true,
			texture="&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/drive.tif",
			tooltip = "Allows the Maxim Artillery to move again.\r\nHint: this takes a few seconds to do.",
			})
end
gadgetHandler:RegisterGlobal("DriveMaximArty", DriveMaximArty)

function gadget:UnitCreated(u, ud, team)
	if MaximArtyDeploy_able[Spring.GetUnitDefID(u)] then
		Spring.InsertUnitCmdDesc(u, MaximArty_Deploy)
	end
end

function gadget:CommandFallback(u, ud, team, cmd, param, opts)
	if cmd  == CMD_MAXIMARTY_DEPLOY then
		local x,y,z = Spring.GetUnitPosition(u)
		local group = Spring.GetUnitsInSphere(x,y,z,350)
		for i,k in ipairs(group) do
			local unitID = Spring.GetUnitDefID(k)
			if Shielded[unitID] then
				Spring.Echo("Shield nearby, can't deploy!")
				return true, true;
			end
		end
		Spring.CallCOBScript(u, "Transform", 0)
	return true, true;
	end
	return false
end

------------------------------------------------------------------------
----------------------------------------------------------------
-----------------------------------------------END
end