function gadget:GetInfo()
	return 
	{
		name = "Prone",
		desc = "Allows Resistance Troopers to drop prone on command.",
		author = "Argh",
		date = "March 20th, 2008",
		license = "(C) Wolfe Games",
		layer = 1,
		enabled = true
	}
end

local CanProne = {}

local CMD_PRONE = 32610

if (gadgetHandler:IsSyncedCode()) then
-----------------------------------------------SYNCHED
----------------------------------------------------------------
------------------------------------------------------------------------
function gadget:Initialize()
	for ud,_ in pairs(UnitDefs) do
		if UnitDefs[ud].customParams.can_go_prone == 'yes' then
			table.insert(CanProne,ud,1)
		end
	end
end


Prone = {
		id=CMD_PRONE,
		type=CMDTYPE.ICON,
		name="",
		onlyTexture=true,
		texture="&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/KNEEL.png",
		tooltip="Commands the soldier to kneel.\r\nHint: this makes infantry much harder see, and therefore kill.",
		}

local function GoProneLable(u)
		local cmdID = Spring.FindUnitCmdDesc(u, CMD_PRONE)
		Spring.EditUnitCmdDesc(u, cmdID, {
		name="",
		onlyTexture=true,
		texture="&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/KNEEL.png",
		tooltip="Commands the soldier to kneel.\r\nHint: this makes infantry much harder see, and therefore kill.",
  		})		
end
gadgetHandler:RegisterGlobal("GoProneLable", GoProneLable)

local function StandUpLable(u)
		local cmdID = Spring.FindUnitCmdDesc(u, CMD_PRONE)
		Spring.EditUnitCmdDesc(u, cmdID, {
		name="",
		onlyTexture=true,
		texture="&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/STAND.png",
		tooltip="Commands the soldier to stand up again.",
  		})		
end
gadgetHandler:RegisterGlobal("StandUpLable", StandUpLable)

function gadget:UnitCreated(u, ud, team)
	if CanProne[ud] then
		Spring.InsertUnitCmdDesc(u, Prone)
	end
end

function gadget:CommandFallback(u, ud, team, cmd, param, opts)
	if cmd  == CMD_PRONE then
		if CanProne[ud] then
			Spring.CallCOBScript(u, "GoProne", 0)
			return true, true;
		end
	end
	return false
end
------------------------------------------------------------------------
----------------------------------------------------------------
-----------------------------------------------END
end