function gadget:GetInfo()
	return {
		name = "TeamDamage",
		desc = "P.U.R.E.'s Team Damage Prevention",
		author = "Argh",
		date = "December 10th, 2008",
		license = "Public Domain, or the least-restrictive rights in your country of residence",
		layer = 0,
		enabled = true,
	}
end

local Health, maxHealth, paralyzeDamage,Random = 0,0,0,1
local a,b = 1,1
local SetUnitHealth = Spring.SetUnitHealth
local GetUnitHealth = Spring.GetUnitHealth
local math_rand = math.random
local CallCOBScript = Spring.CallCOBScript

local exceptionList = {}
local infantryKillerList = {}
local alwaysTakesDamage = {}
local soldierDamage = {}

if (gadgetHandler:IsSyncedCode()) then

function gadget:Initialize()
	for i=1,#WeaponDefs do  --search all WeaponDef entries
		if string.find(WeaponDefs[i].description,"(teamdamage)") then
			table.insert(exceptionList,i,1)
		end
		if string.find(WeaponDefs[i].description,"(infantry killer)") then
			table.insert(infantryKillerList,i,1)
		end
	end

	for ud,_ in pairs(UnitDefs) do  -- search all UnitDef entries
		if UnitDefs[ud].customParams.always_takes_damage ~= nil then
			if UnitDefs[ud].customParams.always_takes_damage == 'yes' then
				table.insert(alwaysTakesDamage,ud,1)
			end
		end
		if UnitDefs[ud].customParams.is_small ~= nil then
			if UnitDefs[ud].customParams.is_small == 'yes' then
				table.insert(soldierDamage,ud,1)
			end
		end
	end
end

function gadget:UnitDamaged(unitID, unitDefID, unitTeam, damage, paralyzer, weaponID, attackerID, attackerDefID, attackerTeam)
	if unitTeam == attackerTeam then
		Health, maxHealth, paralyzeDamage = GetUnitHealth(unitID)
		if not exceptionList[weaponID] and not alwaysTakesDamage[unitDefID] then
			if paralyzer then
				SetUnitHealth(unitID,{paralyze = damage + paralyzeDamage})
			else
				if Health + damage < maxHealth then
					SetUnitHealth(unitID,{health = Health + damage})
				else
					SetUnitHealth(unitID,{health = maxHealth})
				end
			end
		end
	else
		if soldierDamage[unitDefID] then
			_,getProne = CallCOBScript(unitID, "ProneState", 4, a, b)
			--Spring.Echo(a,getProne)
			if paralyzer then
				SetUnitHealth(unitID,{paralyze = 0}) --no Paralyze for infantry!
			else
				Random = math_rand(1,6)
				if getProne == 1 then
					if Random < 3 or infantryKillerList[weaponID] then
						--normal damage results
					else
						--prone nullified results
						if Health + damage < maxHealth then
							SetUnitHealth(unitID,{health = Health + damage})
						else
							SetUnitHealth(unitID,{health = maxHealth})
						end
					end
				end
			end
		end		
	end
end

end