function gadget:GetInfo()
	return 
	{
		name = "Transform Advance Base",
		desc = "Allows Advance Base to transform to mobile mode.",
		author = "Argh",
		date = "March 20th, 2008",
		license = "(C) Wolfe Games",
		layer = 1,
		enabled = true
	}
end

local CanTransformIntoBase = {
    [UnitDefNames.advancebase.id] = "advancebase",
    [UnitDefNames.advancebase_mobile.id] = "advancebase_mobile",
}

local CMD_TRANSFORM_ADVANCEBASE = 32607

if (gadgetHandler:IsSyncedCode()) then
-----------------------------------------------SYNCHED
----------------------------------------------------------------
------------------------------------------------------------------------
TransformAdvanceBase = {
		id=CMD_TRANSFORM_ADVANCEBASE,
		type=CMDTYPE.ICON,
		name="",
		onlyTexture=true,
		texture="&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/transform.tif",
		tooltip="Allows Factory to transform to/from mobile mode.\r\nHint: once started, the transformation will not stop.",
		action="transform"
		}

function AdvanceBaseTransformCommand(u, ud, team)
	Spring.InsertUnitCmdDesc(u, TransformAdvanceBase)
end
gadgetHandler:RegisterGlobal("AdvanceBaseTransformCommand", AdvanceBaseTransformCommand)

--NOTE:  THIS USES ALLOWCOMMAND, NOT COMMANDFALLBACK, UNKNOWN WHY FALLBACK DOES NOT WORK FOR A FACTORY
function gadget:AllowCommand(u, ud, team, cmd, param, opts)
	if (cmd ~= CMD_TRANSFORM_ADVANCEBASE) then	
    		return true -- command was not used
	else
		if CanTransformIntoBase[ud] then
			--Spring.RemoveUnitCmdDesc(u, TransformAdvanceBase)
			local cmdID = Spring.FindUnitCmdDesc(u, CMD_TRANSFORM_ADVANCEBASE)
			Spring.EditUnitCmdDesc(u,cmdID,{disabled = true, tooltip = "Transformation started.",})
			Spring.CallCOBScript(u, "TransformAdvanceBase", 0)
			return false
		end
	end
	return true -- if all else fails
end
------------------------------------------------------------------------
----------------------------------------------------------------
-----------------------------------------------END
end
