function gadget:GetInfo()
	return 
	{
		name = "Transform Air Base",
		desc = "Allows Air Base to transform to mobile mode.",
		author = "Argh",
		date = "March 20th, 2008",
		license = "(C) Wolfe Games",
		layer = 1,
		enabled = true
	}
end

local CanTransformIntoBase = {
    [UnitDefNames.airbase.id] = "airbase",
    [UnitDefNames.airbase_mobile.id] = "airbase_mobile",
}

local CMD_TRANSFORM_AIRBASE = 32616

if (gadgetHandler:IsSyncedCode()) then
-----------------------------------------------SYNCHED
----------------------------------------------------------------
------------------------------------------------------------------------
TransformAirBase = {
		id=CMD_TRANSFORM_AIRBASE,
		type=CMDTYPE.ICON,
		name="",
		onlyTexture=true,
		texture="&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/transform.tif",
		tooltip="Allows Air Base to transform to/from mobile mode.\r\nHint: once started, the transformation will not stop.",
		action="transform"
		}

function AirBaseTransformCommand(u, ud, team)
	Spring.InsertUnitCmdDesc(u, TransformAirBase)
end
gadgetHandler:RegisterGlobal("AirBaseTransformCommand", AirBaseTransformCommand)

--NOTE:  THIS USES ALLOWCOMMAND, NOT COMMANDFALLBACK, UNKNOWN WHY FALLBACK DOES NOT WORK FOR A FACTORY
function gadget:AllowCommand(u, ud, team, cmd, param, opts)
	if  cmd ~= CMD_TRANSFORM_AIRBASE then
		return true
	else
		if CanTransformIntoBase[ud] then
			local valid = 1
			local x,y,z = Spring.GetUnitPosition(u)
			local height = Spring.GetGroundHeight(x,z)
			local MaxSizeX = Game.mapSizeX
			local MaxSizeZ = Game.mapSizeZ
			if x < 0  or  x > MaxSizeX or z < 0 or z > MaxSizeZ or height < -5 then valid = 0 else valid = 1 end
			if valid == 1 then
				local cmdID = Spring.FindUnitCmdDesc(u, CMD_TRANSFORM_AIRBASE)
				if cmdID ~= nil then
					Spring.EditUnitCmdDesc(u,cmdID,{disabled = true, tooltip = "Transformation started.",})
					--Spring.RemoveUnitCmdDesc(u, TransformAirBase)
					Spring.CallCOBScript(u, "TransformAirBase", 0)
				return false
				end
			else
				return true
			end
		end
		return true
	end
end
------------------------------------------------------------------------
----------------------------------------------------------------
-----------------------------------------------END
end
