function gadget:GetInfo()
	return 
	{
		name = "Transform Multi Truck",
		desc = "Allows Multi Truck to change to different modes.",
		author = "Argh",
		date = "February 9th, 2009",
		license = "(C) Wolfe Games",
		layer = 1,
		enabled = true
	}
end

local CanTransformIntoBuilding = {
    [UnitDefNames.resistance_multitruck_mobile.id] = "resistance_multitruck_mobile",
}

local CMD_TRANSFORM_MULTITRUCK_PILLBOX = 32617
local CMD_TRANSFORM_MULTITRUCK_PILLBOX_RADAR = 32618
local CMD_TRANSFORM_MULTITRUCK_PILLBOX_AA = 32619

if (gadgetHandler:IsSyncedCode()) then
-----------------------------------------------SYNCHED
----------------------------------------------------------------
------------------------------------------------------------------------
TransformMultiTruckPillbox = {
		id=CMD_TRANSFORM_MULTITRUCK_PILLBOX,
		type=CMDTYPE.ICON,
		name="",
		onlyTexture=true,
		texture="&.9x.9&bitmaps/icons/blank.tif&unitpics/Resistance_MultiTruck_Pillbox.bmp",
		tooltip="Allows MultiTruck to transform into a Pillbox.\r\nHint: once started, the transformation will not stop.",
		action="transform"
		}

TransformMultiTruckPillbox_Radar = {
		id=CMD_TRANSFORM_MULTITRUCK_PILLBOX_RADAR,
		type=CMDTYPE.ICON,
		name="",
		onlyTexture=true,
		texture="&.9x.9&bitmaps/icons/blank.tif&unitpics/Resistance_MultiTruck_Pillbox_Radar.bmp",
		tooltip="Allows MultiTruck to transform into a Pillbox with Radar.\r\nHint: once started, the transformation will not stop.",
		action="transform"
		}


TransformMultiTruckPillbox_AA = {
		id=CMD_TRANSFORM_MULTITRUCK_PILLBOX_AA,
		type=CMDTYPE.ICON,
		name="",
		onlyTexture=true,
		texture="&.9x.9&bitmaps/icons/blank.tif&unitpics/Resistance_MultiTruck_Pillbox_AA.bmp",
		tooltip="Allows MultiTruck to transform into a Pillbox with an AA gun.\r\nHint: once started, the transformation will not stop.",
		action="transform"
		}

function MultiTruckTransformCommand(u, ud, team)
	Spring.InsertUnitCmdDesc(u, TransformMultiTruckPillbox)
	Spring.InsertUnitCmdDesc(u, TransformMultiTruckPillbox_Radar)
	Spring.InsertUnitCmdDesc(u, TransformMultiTruckPillbox_AA)
end
gadgetHandler:RegisterGlobal("MultiTruckTransformCommand", MultiTruckTransformCommand)

function TransformMultiTruck_Post(u, ud, team, var)

	local x, y, z = Spring.GetUnitPosition(u)
	local heading = Spring.GetUnitHeading(u)
	
	--Spring.Echo (heading)
	
	if heading < 1600 and heading > -1600 then heading = 0 end
	if heading < 17000 and heading > 15000 then heading = 1 end
	if heading > 31000 and heading < 32769 or heading < -31000 and heading > -32769 then heading = 2 end
	if heading < -15000 and heading > -17000 then heading = 3 end

	Spring.SetUnitNoDraw(u,true)
	Spring.SetUnitNoSelect(u,true)
	Spring.SetUnitNoMinimap(u,true)
	local health = Spring.GetUnitHealth(u)
	
	if var == 1 then
		DelayedCall(function()
			local y = Spring.CreateUnit("Resistance_MultiTruck_Pillbox", x,y,z, heading, team)
			Spring.DestroyUnit(u,false,true)
	
			local TeamValue = Spring.GetUnitTeam(y)
			SendToUnsynced("SelectMe", y, TeamValue)
		end)
	end

	if var == 2 then
		DelayedCall(function()
			local y = Spring.CreateUnit("Resistance_MultiTruck_Pillbox_Radar", x,y,z, heading, team)
			Spring.DestroyUnit(u,false,true)
	
			local TeamValue = Spring.GetUnitTeam(y)
			SendToUnsynced("SelectMe", y, TeamValue)
		end)
	end

	if var == 3 then
		DelayedCall(function()
			local y = Spring.CreateUnit("Resistance_MultiTruck_Pillbox_AA", x,y,z, heading, team)
			Spring.DestroyUnit(u,false,true)

	
			local TeamValue = Spring.GetUnitTeam(y)
			SendToUnsynced("SelectMe", y, TeamValue)
		end)
	end

end
gadgetHandler:RegisterGlobal("TransformMultiTruck_Post", TransformMultiTruck_Post)

--////////////////////////////////////////////////////////////////////  SAFE DELAYED FUNCTION
local delayedCalls = {}
function DelayedCall(fun)
	delayedCalls[#delayedCalls+1] = fun 
end


function gadget:GameFrame(f)
	for i=1,#delayedCalls do
		local fun = delayedCalls[i]
		fun()
	end
	delayedCalls = {}
end
--////////////////////////////////////////////////////////////////////

function gadget:CommandFallback(u, ud, team, cmd, param, opts)
	if (cmd == CMD_TRANSFORM_MULTITRUCK_PILLBOX) then
		if CanTransformIntoBuilding[ud] then
			Spring.CallCOBScript(u, "TransformMultiTruckNow", 0, 1)
			local cmdID
			cmdID = Spring.FindUnitCmdDesc(u, CMD_TRANSFORM_MULTITRUCK_PILLBOX)
			Spring.EditUnitCmdDesc(u,cmdID,{disabled = true, tooltip = "Transformation started.",})
			cmdID = Spring.FindUnitCmdDesc(u, CMD_TRANSFORM_MULTITRUCK_PILLBOX_RADAR)
			Spring.EditUnitCmdDesc(u,cmdID,{disabled = true, tooltip = "Transformation started.",})
			cmdID = Spring.FindUnitCmdDesc(u, CMD_TRANSFORM_MULTITRUCK_PILLBOX_AA)
			Spring.EditUnitCmdDesc(u,cmdID,{disabled = true, tooltip = "Transformation started.",})
			return true, true;
		end
	end

	if (cmd == CMD_TRANSFORM_MULTITRUCK_PILLBOX_RADAR) then
		if CanTransformIntoBuilding[ud] then
			Spring.CallCOBScript(u, "TransformMultiTruckNow", 0, 2)
			local cmdID
			cmdID = Spring.FindUnitCmdDesc(u, CMD_TRANSFORM_MULTITRUCK_PILLBOX)
			Spring.EditUnitCmdDesc(u,cmdID,{disabled = true, tooltip = "Transformation started.",})
			cmdID = Spring.FindUnitCmdDesc(u, CMD_TRANSFORM_MULTITRUCK_PILLBOX_RADAR)
			Spring.EditUnitCmdDesc(u,cmdID,{disabled = true, tooltip = "Transformation started.",})
			cmdID = Spring.FindUnitCmdDesc(u, CMD_TRANSFORM_MULTITRUCK_PILLBOX_AA)
			Spring.EditUnitCmdDesc(u,cmdID,{disabled = true, tooltip = "Transformation started.",})
			return true, true;
		end
	end

	if (cmd == CMD_TRANSFORM_MULTITRUCK_PILLBOX_AA) then
		if CanTransformIntoBuilding[ud] then
			Spring.CallCOBScript(u, "TransformMultiTruckNow", 0, 3)
			local cmdID
			cmdID = Spring.FindUnitCmdDesc(u, CMD_TRANSFORM_MULTITRUCK_PILLBOX)
			Spring.EditUnitCmdDesc(u,cmdID,{disabled = true, tooltip = "Transformation started.",})
			cmdID = Spring.FindUnitCmdDesc(u, CMD_TRANSFORM_MULTITRUCK_PILLBOX_RADAR)
			Spring.EditUnitCmdDesc(u,cmdID,{disabled = true, tooltip = "Transformation started.",})
			cmdID = Spring.FindUnitCmdDesc(u, CMD_TRANSFORM_MULTITRUCK_PILLBOX_AA)
			Spring.EditUnitCmdDesc(u,cmdID,{disabled = true, tooltip = "Transformation started.",})
			return true, true;
		end
	end

	return false
end
------------------------------------------------------------------------
----------------------------------------------------------------
-----------------------------------------------END
end
