function gadget:GetInfo()
	return 
	{
		name = "Transform Power Generator",
		desc = "Allows Power Generator to tech up.",
		author = "Argh",
		date = "February 9th, 2009",
		license = "(C) Wolfe Games",
		layer = 1,
		enabled = true
	}
end

local powerGenerator = {}

local CMD_TRANSFORM_POWER_GENERATOR = 32620

if (gadgetHandler:IsSyncedCode()) then
-----------------------------------------------SYNCHED
----------------------------------------------------------------
------------------------------------------------------------------------
TransformPowerGenerator = {
		id=CMD_TRANSFORM_POWER_GENERATOR,
		type=CMDTYPE.ICON,
		name="",
		onlyTexture=true,
		texture="&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/transform.tif",
		tooltip="Transforms Power Generator to more powerful form.\r\nCosts 500 Materials.",
		action="transform"
		}

function gadget:Initialize()
	for ud,_ in pairs(UnitDefs) do
		if UnitDefs[ud].customParams.upgrade_type == 'powergenerator_tier2' then
			table.insert(powerGenerator,ud,1)
		end
	end
end

function gadget:UnitFinished(u,ud,team)
	if powerGenerator[ud] then
		Spring.InsertUnitCmdDesc(u, TransformPowerGenerator)
	end
end

--////////////////////////////////////////////////////////////////////  SAFE DELAYED CALLS
local delayedCalls = {}
function DelayedCall(fun)
	delayedCalls[#delayedCalls+1] = fun 
end

function gadget:GameFrame(f)
	for i=1,#delayedCalls do
		local fun = delayedCalls[i]
		fun()
	end
	delayedCalls = {}
end
--////////////////////////////////////////////////////////////////////


function gadget:CommandFallback(u, ud, team, cmd, param, opts)
	if cmd == CMD_TRANSFORM_POWER_GENERATOR then
		if powerGenerator[ud] then
			DelayedCall(function()
				local materials = Spring.GetTeamResources(team, 'metal')
				local cost = tonumber(UnitDefs[ud].customParams.upgrade_cost)
				if materials >= cost then

					Spring.UseTeamResource(team,'m',cost)
					local x,y,z = Spring.GetUnitPosition(u)
					Spring.SpawnCEG("transform_flash_fx", x, y, z, 0, 1.0, 0,0,0)
					local facing = Spring.GetUnitBuildFacing(u)
					Spring.CreateUnit('powergenerator_tier2', x, y, z,facing,team)
					Spring.SetUnitNeutral(u,true)
					Spring.DestroyUnit(u,false,true)
			
				else
					Spring.SendMessageToTeam(team,"Not enough Materials!")
				end
			end)
			return true, true;
		end		
	end
	return false
end
------------------------------------------------------------------------
----------------------------------------------------------------
-----------------------------------------------END
end
