function gadget:GetInfo()
	return 
	{
		name = "Transform Heavy Trooper",
		desc = "Allows Heavy Troopers to transform between flight / ground modes.",
		author = "Argh",
		date = "July 3, 2008",
		license = "(C) Wolfe Games",
		layer = 1,
		enabled = true
	}
end

local CanTransformIntoBase = {
    [UnitDefNames.resistance_heavytrooper_spawn_airmode.id] = "resistance_heavytrooper_spawn_airmode",
	[UnitDefNames.resistance_heavytrooper_spawn.id] = "resistance_heavytrooper_spawn",
[UnitDefNames.resistance_heavytrooper.id] = "resistance_heavytrooper",
}

local CMD_TRANSFORM_HEAVYTROOPER = 32615

if (gadgetHandler:IsSyncedCode()) then
-----------------------------------------------SYNCHED
----------------------------------------------------------------
------------------------------------------------------------------------
TransformHeavyTrooper = {
		id=CMD_TRANSFORM_HEAVYTROOPER,
		type=CMDTYPE.ICON,
		name="",
		onlyTexture=true,
		texture="&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/transform.tif",
		tooltip="Allows Heavy Trooper to go from Flight Mode to Ground Mode.\r\nHint: once started, the transformation will not stop.",
		action="transform"
		}

function HeavyTrooperTransformCommand(u, ud, team)
	Spring.InsertUnitCmdDesc(u, TransformHeavyTrooper)
end
gadgetHandler:RegisterGlobal("HeavyTrooperTransformCommand", HeavyTrooperTransformCommand)


function gadget:UnitFinished(u, ud, team)
	if CanTransformIntoBase[ud] ~= nil then
		Spring.InsertUnitCmdDesc(u, TransformHeavyTrooper)
	end
end


function gadget:CommandFallback(u, ud, team, cmd, param, opts)
	if cmd  == CMD_TRANSFORM_HEAVYTROOPER then
		if CanTransformIntoBase[ud] then
			local valid = 1
			local x,y,z = Spring.GetUnitPosition(u)
			local height = Spring.GetGroundHeight(x,z)
			local MaxSizeX = Game.mapSizeX
			local MaxSizeZ = Game.mapSizeZ
			if x < 0  or  x > MaxSizeX or z < 0 or z > MaxSizeZ or height < -5 then valid = 0 else valid = 1 end
			if valid == 1 then
				Spring.CallCOBScript(u, "TransformHeavyTrooper", 0)
				--Spring.RemoveUnitCmdDesc(u, TransformHeavyTrooper)
				local cmdID = Spring.FindUnitCmdDesc(u, cmd)
				Spring.EditUnitCmdDesc(u,cmdID,{disabled = true, tooltip = "Transformation started.",})
			end
			return true, true;
		end
	end
	return false
end

------------------------------------------------------------------------
----------------------------------------------------------------
-----------------------------------------------END
end
