function gadget:GetInfo()
	return {
		name = "Wreckage",
		desc = "Sets wreckage states for dead buildings",
		author = "Argh",
		date = "April 20th, 2009",
		license = "(C) Wolfe Games, 2009",
		layer = 1,
		enabled = true,
	}
end

local math_rand = math.random
local GetUnitPosition = Spring.GetUnitPosition
local CreateUnit = Spring.CreateUnit

local SetUnitNeutral = Spring.SetUnitNeutral
local Gaia = Spring.GetGaiaTeamID()

local BigWrecks = {}
local SmallWrecks = {}
local x,y,z = 0,0,0

if (gadgetHandler:IsSyncedCode()) then
--////////////////////////////////////////////////////////////////////
--////////////////////////////////////////////////////////////////////
--////////////////////////////////////////////////////////////////////
function gadget:Initialize()
	for ud,_ in pairs(UnitDefs) do
		if UnitDefs[ud].customParams.wreckage_type == 'big_wrecks' then
			table.insert(BigWrecks,ud,1)
		end
		if UnitDefs[ud].customParams.wreckage_type == 'small_wrecks' then
			table.insert(SmallWrecks,ud,1)
		end
	end
end

function gadget:UnitDestroyed(u,ud,team)
	if BigWrecks[ud] then
		DelayedCall(function()
			x,y,z = GetUnitPosition(u)
			local new = CreateUnit("ZZZ_Building_Wreckage01",x,y,z,0,Gaia)
			SetUnitNeutral(new,true)
		end)
	end
	if SmallWrecks[ud] then
		DelayedCall(function()
			x,y,z = GetUnitPosition(u)
			local facing = math_rand(0,3)
			local new = CreateUnit("ZZZ_Small_Building_Wreckage01",x,y,z,facing,Gaia)
			SetUnitNeutral(new,true)
		end)
	end
end

--////////////////////////////////////////////////////////////////////  SAFE DELAYED FUNCTION
local delayedCalls = {}
function DelayedCall(fun)
	delayedCalls[#delayedCalls+1] = fun 
end


function gadget:GameFrame(f)
	for i=1,#delayedCalls do
		local fun = delayedCalls[i]
		fun()
	end
	delayedCalls = {}
end
--////////////////////////////////////////////////////////////////////

end