function gadget:GetInfo()
	return {
		name = "group_select.lua",
		desc = "Group Selector, for P.U.R.E.",
		author = "Argh",
		date = "March 13th, 2008",
		license = "Copyright (C) Wolfe Games, 2008",
		layer = 1,
		enabled = true,
	}
end

local CanGroupSelect = {
[UnitDefNames.resistance_heavytrooper.id] = "resistance_heavytrooper",
 [UnitDefNames.resistance_heavytrooper_spawn.id] = "resistance_heavytrooper_spawn",
 [UnitDefNames.resistance_heavytrooper_spawn_airmode.id] = "resistance_heavytrooper_spawn_airmode",
    [UnitDefNames.resistancetrooper.id] = "resistancetrooper",
    [UnitDefNames.resistancetrooper_spawn.id] = "resistancetrooper_spawn",
    [UnitDefNames.resistancetrooper_rocket.id] = "resistancetrooper_rocket",
    [UnitDefNames.lightmech.id] = "lightmech",
    [UnitDefNames.lightmech_rocket.id] = "lightmech_rocket",
    [UnitDefNames.lightmech_aa.id] = "lightmech_aa",
[UnitDefNames.resistance_sniper.id] = "resistance_sniper",
[UnitDefNames.resistance_grenadier.id] = "resistance_grenadier",
}
local CMD_GROUP_SELECT = 32608

local DeadGroup = {}  -- For our local dead unit clearing code!

local tremove = table.remove

if (gadgetHandler:IsSyncedCode()) then
-----------------------------------------------SYNCHED
----------------------------------------------------------------
------------------------------------------------------------------------
GroupSelect = {
		id=CMD_GROUP_SELECT,
		type=CMDTYPE.ICON,
		name="",
		onlyTexture=true,
		texture="&.9x.9&bitmaps/icons/blank.tif&bitmaps/icons/GROUP.png",
		tooltip="Click to select the entire squad automatically.",
		action="group select"
		}


function gadget:UnitCreated(u, ud, team)
	if CanGroupSelect[Spring.GetUnitDefID(u)] then
		Spring.InsertUnitCmdDesc(u, GroupSelect)
	end
end


function gadget:CommandFallback(u, ud, team, cmd, param, opts)
	if (cmd == CMD_GROUP_SELECT) then
 		SendToUnsynced("SelectMyGroup", u, team)
	return true, true;
	end
	return false
end

function gadget:UnitDestroyed(unitID, unitDefID, unitTeam)
	DeadGroup[#DeadGroup+1] = unitID 
		--Note that this is really small code.  That way, each UnitDestroyed event isn't tied up with giant searches, etc.
end

function gadget:GameFrame(f)
	--Dead Unit Clearing Code.  It's very important to keep this list short, and run as infrequently as possible.
	-- This is a very, very long search, when there are hundreds of units built.
	    if (((f+8) % 65) < 0.1) then
			if UnitGroups ~= nil then
				for k,v in ipairs (UnitGroups) do
					--Check matches between the Units that died (DeadGroup) and UnitGroups
					if DeadGroup ~= nil then
						for _,u in ipairs(DeadGroup) do
							if u == v.Individual then
								--Spring.Echo ("removing dead things",v,v.GroupNumber,v.Individual) 								--Troubleshooting code, if you're having problems with the lists
								--Remove the key (indice) that contains the dead Unit's GroupNumber and Individual ID, clearing the clutter)
								tremove(UnitGroups,k)
								--More troubleshooting code, to make sure the list is getting cleared of all junk!
								--[[for k,v in ipairs(UnitGroups) do
									Spring.Echo(k,v)
								end]]
							end
						end
					else return end
				end
			else return end
		end
	end

----------------------------------------------------------------
------------------------------------------------------------------------
else
------------------------------------------------------------------------
----------------------------------------------------------------
-----------------------------------------------UNSYNCHED
local TeamID = Spring.GetLocalTeamID()
local GoodGroup
local SYNCED = SYNCED
local SelectUnitArray = Spring.SelectUnitArray
local MyUnitGroups = SYNCED.UnitGroups

function gadget:RecvFromSynced(name,u,teamValue)
	if (name == 'SelectMyGroup') and teamValue == TeamID then
	    --Spring.Echo ("running command",u) -- Checking code, simple.
		for _,v in spairs (MyUnitGroups) do
			--Check matches between members of the list and UnitGroups
			if u == v.Individual then
				--Spring.Echo("match",v.GroupNumber)
				GoodGroup = v.GroupNumber
				for _,v in spairs (MyUnitGroups) do
					if v.GroupNumber == GoodGroup then
						SelectUnitArray({v.Individual},true)
					end
				end
			end
		end
	end
	return false
end
----------------------------------------------------------------
-----------------------------------------------END
----------------------------------------------------------------
end