function widget:GetInfo()
  return {
	name="Console Fixes",
	desc="Fixes the console display to look more professional and fit P.U.R.E.",
	author="Argh",
	date="April 22nd, 2009",
	license="Public Domain, or the least-restrictive rights in your country of residence",
	layer=0,
	enabled=true
	}
end

local string_format = string.format
local string_find = string.find

local glTexRect = gl.TexRect
local glTexture = gl.Texture
local glColor = gl.Color
local glText = gl.Text
local  IsGUIHidden = Spring.IsGUIHidden
local glGetViewSizes = gl.GetViewSizes

local xMinConsole, xMaxConsole, yMinConsole, yMaxConsole
local textSize,gapSize,xOffset, yOffset = 0,0,0,0,0,0
local consoleTex = 'bitmaps/ui/Console.png'

local OtherStuff = {}
local ShutDown = 0
local myLine, xLine = 0,0
local addLine,startMe = 0,0

function widget:Initialize()
	Spring.SendCommands({"console 0"})

	local vsx, vsy = glGetViewSizes()

  	xMinConsole = vsx  * (0.38) -- (800 - 192) / 1600
  	xMaxConsole = vsx  * (0.62) -- (800 + 192) /1600
  	yMinConsole = vsy * (0.84) -- (1200 - 192) / 1200      -NOTE:  Main UI is 512 pixels high!
  	yMaxConsole = vsy

	textSize = 16 * (vsx / 1600)
	gapSize = 18 * (vsy / 1200)
	xOffset = 620 *( vsx  / 1600)
	yOffset = 1180 * (vsy / 1200)

end

function widget:ShutDown()
	ShutDown = 1
	Spring.SendCommands({"console 1"})
	widgetHandler:RemoveWidget()
end

function widget:AddConsoleLine(msg,priority)
	if addLine == 1 and string.find(msg,'bad return value') == nil then
		table.insert(OtherStuff,msg)
		if #OtherStuff > 10 then
			table.remove(OtherStuff,1)
		end
	end
end

function widget:GameFrame(f)
	if f == 1 then
		startMe = 1
	end
	if f == 120 then
		OtherStuff = {}
		addLine = 1
	end
end

function widget:ViewResize(viewSizeX, viewSizeY)
  	xMinConsole = viewSizeX  * (0.38) -- (800 - 192) / 1600
  	xMaxConsole = viewSizeX  * (0.62) -- (800 + 192) /1600
  	yMinConsole = viewSizeY * (0.84) -- (1200 - 192) / 1200      -NOTE:  Main UI is 512 pixels high!
  	yMaxConsole = viewSizeY

	textSize = 16 * (viewSizeX / 1600)
	gapSize = 18 * (viewSizeY / 1200)
	xOffset = 620 *( viewSizeX  / 1600)
	yOffset = 1180 * (viewSizeY / 1200)
end

function widget:DrawScreenEffects()
	if IsGUIHidden() == false and startMe == 1 then
		glTexture(consoleTex)
		glColor(1,1,1,1)
		glTexRect(xMinConsole,yMinConsole,xMaxConsole,yMaxConsole)
	end

	if IsGUIHidden() == false and OtherStuff ~= nil and addLine == 1 then
		myLine = 0
		xLine = 0
		for _,line in pairs(OtherStuff) do
			glColor(1,0.75 + (myLine / 30),0 + (myLine / 10),1)
			glText(line,xOffset, yOffset - xLine,textSize, "n")
			xLine = xLine + gapSize
			myLine = myLine +1
		end
	end
end