function widget:GetInfo()
  return {
	name="Options Menu",
	desc="Runs the Options Menu.",
	author="Argh",
	date="March 25th, 2009",
	license="Public Domain, or the least-restrictive rights in your country of residence",
	layer=0,
	handler=true,
	enabled=true,
	}
end
include("keysym.h.lua")

local optionsOpen = 0

local GetGameFrame = Spring.GetGameFrame
local IsGUIHidden = Spring.IsGUIHidden
local glTexture = gl.Texture
local glColor = gl.Color
local glTexRect = gl.TexRect
local glGetViewSize = gl.GetViewSize

local viewX,viewY,oldviewX,oldviewY
local BriefValue = 0
local buttonValue = 1
local DrawGuide = false
local currentTexture = 'bitmaps/options/options.png'
local OptionsStaticTexture = 'bitmaps/options/options_static.png'
local xGuideHelp, yGuideHelp
local xMinGuideHelp, xMaxGuideHelp, yMinGuideHelp, yMaxGuideHelp
local startDrawing = 0

local GroundDetail = {}
local Shadows = {}
local WaterDetail = {}
local Music = {}
local MainVolume = {}
local ReplyVolume = {}
local QuitBox = {}
local GameSpeed = {}
local OptionsStatic = {}
local UnitDistance = {}
local ViewFPS = {}
local UnitDistance = {}
local myExitOptions = {}
local CameraMode = {}

local CameraModeState = 1
local ViewFPSState = 0
local UnitDistanceState = 0
local UnitDistanceState = 0
local GroundDetailState = 0
local ShadowsState = 0
local WaterDetailState = 0
local MusicState = 2
local MainVolumeState = 0
local ReplyVolumeState = 0

function widget:MousePress(x, y, button)
	if optionsOpen == 0 then
		if button == 1 then
			if x > OptionsStatic.xMin1 and x < OptionsStatic.xMax1 and y > OptionsStatic.yMin1 and y < OptionsStatic.yMax1 then
				optionsOpen = 1
				return
			end
		end
	end

	if optionsOpen == 1 then
		if button == 1 then
			--CLOSE OPTIONS
			if x > OptionsStatic.xMin1 and x < OptionsStatic.xMax1 and y > OptionsStatic.yMin1 and y < OptionsStatic.yMax1 then
				optionsOpen = 0
				return
			end
			
			--CLOSE OPTIONS 2
			if x > myExitOptions.xMin1 and x < myExitOptions.xMax1 and y < myExitOptions.yMin1 and y > myExitOptions.yMax1 then
				optionsOpen = 0
				return
			end

			--QUIT
			if x > QuitBox.xMin1 and x < QuitBox.xMax1 and y < QuitBox.yMin1 and y > QuitBox.yMax1 then
				Spring.SendCommands({"quitforce"})
			end

			--FPS COUNTER
			if x > ViewFPS.xMin1 and x < ViewFPS.xMax1 and y < ViewFPS.yMin1 and y > ViewFPS.yMax1 then
				Spring.SendCommands({"fps 1"})
				ViewFPSState = 1
			end
			if x > ViewFPS.xMin2 and x < ViewFPS.xMax2 and y < ViewFPS.yMin2 and y > ViewFPS.yMax2 then
				Spring.SendCommands({"fps 0"})
				ViewFPSState = 0
			end

			--ICON DISTANCE
			if x > UnitDistance.xMin1 and x < UnitDistance.xMax1 and y < UnitDistance.yMin1 and y > UnitDistance.yMax1 then
				local UnitIconDist =  tonumber(Spring.GetConfigString("UnitIconDist",1))
				local UnitLodDist =  tonumber(Spring.GetConfigString("UnitLodDist",1))
				Spring.SetConfigString("UnitLodDist", (300)) 
				Spring.SetConfigString("UnitIconDist", (299))
				UnitDistanceState = 1
				Spring.Echo("Icon Distance Set to Near.")
			end
			if x > UnitDistance.xMin2 and x < UnitDistance.xMax2 and y < UnitDistance.yMin2 and y > UnitDistance.yMax2 then
				local UnitIconDist =  tonumber(Spring.GetConfigString("UnitIconDist",1))
				local UnitLodDist =  tonumber(Spring.GetConfigString("UnitLodDist",1))
				Spring.SetConfigString("UnitLodDist", (500))
				Spring.SetConfigString("UnitIconDist", (499))
				UnitDistanceState = 2
				Spring.Echo("Icon Distance Set to Medium.")
			end
			if x > UnitDistance.xMin3 and x < UnitDistance.xMax3 and y < UnitDistance.yMin3 and y > UnitDistance.yMax3 then
				local UnitIconDist =  tonumber(Spring.GetConfigString("UnitIconDist",1))
				local UnitLodDist =  tonumber(Spring.GetConfigString("UnitLodDist",1))
				Spring.SetConfigString("UnitLodDist", (1000))
				Spring.SetConfigString("UnitIconDist", (999))
				UnitDistanceState = 3
				Spring.Echo("Icon Distance Set to Far.")
			end

			--PARTICLE COUNT
			if x > myParticleCount.xMin1 and x < myParticleCount.xMax1 and y < myParticleCount.yMin1 and y > myParticleCount.yMax1 then
				Spring.SendCommands({"maxparticles 500"})
				myParticleCountState = 1
			end
			if x > myParticleCount.xMin2 and x < myParticleCount.xMax2 and y < myParticleCount.yMin2 and y > myParticleCount.yMax2 then
				Spring.SendCommands({"maxparticles 3000"})
				myParticleCountState = 2
			end
			if x > myParticleCount.xMin3 and x < myParticleCount.xMax3 and y < myParticleCount.yMin3 and y > myParticleCount.yMax3 then
				Spring.SendCommands({"maxparticles 7500"})
				myParticleCountState = 3
			end


			--CAMERA MODES
			if x > CameraMode.xMin1 and x < CameraMode.xMax1 and y < CameraMode.yMin1 and y > CameraMode.yMax1 then
				Spring.SendCommands({"viewta"})
				CameraModeState = 1
			end
			if x > CameraMode.xMin2 and x < CameraMode.xMax2 and y < CameraMode.yMin2 and y > CameraMode.yMax2 then
				Spring.SendCommands({"viewfps"})
				CameraModeState = 2
			end
			if x > CameraMode.xMin3 and x < CameraMode.xMax3 and y < CameraMode.yMin3 and y > CameraMode.yMax3 then
				Spring.SendCommands({"viewtw"})
				CameraModeState = 3
			end

			
			--GROUND DETAIL
			if x > GroundDetail.xMin1 and x < GroundDetail.xMax1 and y < GroundDetail.yMin1 and y > GroundDetail.yMax1 then
				Spring.SendCommands({"decreaseviewradius"})
			end
			if x > GroundDetail.xMin2 and x < GroundDetail.xMax2 and y < GroundDetail.yMin2 and y > GroundDetail.yMax2 then
				Spring.SendCommands({"increaseviewradius"})
			end
			--SHADOWS
			if x > Shadows.xMin1 and x < Shadows.xMax1 and y < Shadows.yMin1 and y > Shadows.yMax1 then
				Spring.SendCommands({"shadows 1 4096"})
				ShadowState = 1
			end
			if x > Shadows.xMin2 and x < Shadows.xMax2 and y < Shadows.yMin2 and y > Shadows.yMax2 then
				Spring.SendCommands({"shadows 0"})
				ShadowState = 0
			end
			
			--WATER
			if x > WaterDetail.xMin1 and x < WaterDetail.xMax1 and y < WaterDetail.yMin1 and y > WaterDetail.yMax1 then
				Spring.SendCommands({"water 0"})
				WaterDetailState = 1
			end
			if x > WaterDetail.xMin2 and x < WaterDetail.xMax2 and y < WaterDetail.yMin2 and y > WaterDetail.yMax2 then
				Spring.SendCommands({"water 1"})
				WaterDetailState = 2
			end
			if x > WaterDetail.xMin3 and x < WaterDetail.xMax3 and y < WaterDetail.yMin3 and y > WaterDetail.yMax3 then
				Spring.SendCommands({"water 4"})
				WaterDetailState = 3
			end

			--MUSIC
			if x > Music.xMin1 and x < Music.xMax1 and y < Music.yMin1 and y > Music.yMax1 then
				Spring.SendCommands({"luaui enablewidget Theme"})
				MusicState = 1
			end
			if x > Music.xMin2 and x < Music.xMax2 and y < Music.yMin2 and y > Music.yMax2 then
				Spring.SendCommands({"luaui disablewidget Theme"})
				MusicState = 0
			end

			--MAIN VOLUME
			if x > MainVolume.xMin1 and x < MainVolume.xMax1 and y < MainVolume.yMin1 and y > MainVolume.yMax1 then
				Spring.SendCommands({"set snd_volmaster 50"})
				MainVolumeState = 1
			end
			if x > MainVolume.xMin2 and x < MainVolume.xMax2 and y < MainVolume.yMin2 and y > MainVolume.yMax2 then
				Spring.SendCommands({"set snd_volmaster 75"})
				MainVolumeState = 2
			end
			if x > MainVolume.xMin3 and x < MainVolume.xMax3 and y < MainVolume.yMin3 and y > MainVolume.yMax3 then
				Spring.SendCommands({"set snd_volmaster 100"})
				MainVolumeState = 3
			end

			--REPLY VOLUME
			if x > ReplyVolume.xMin1 and x < ReplyVolume.xMax1 and y < ReplyVolume.yMin1 and y > ReplyVolume.yMax1 then
				Spring.SendCommands({"set snd_volunitreply 50"})
				ReplyVolumeState = 1
			end
			if x > ReplyVolume.xMin2 and x < ReplyVolume.xMax2 and y < ReplyVolume.yMin2 and y > ReplyVolume.yMax2 then
				Spring.SendCommands({"set snd_volunitreply 75"})
				ReplyVolumeState = 2
			end
			if x > ReplyVolume.xMin3 and x < ReplyVolume.xMax3 and y < ReplyVolume.yMin3 and y > ReplyVolume.yMax3 then
				Spring.SendCommands({"set snd_volunitreply 100"})
				ReplyVolumeState = 3
			end

			--GAME SPEED
			if x > GameSpeed.xMin1 and x < GameSpeed.xMax1 and y < GameSpeed.yMin1 and y > GameSpeed.yMax1 then
				Spring.SendCommands({"pause"})
			end
			if x > GameSpeed.xMin2 and x < GameSpeed.xMax2 and y < GameSpeed.yMin2 and y > GameSpeed.yMax2 then
				Spring.SendCommands({"speedup"})
			end
			if x > GameSpeed.xMin3 and x < GameSpeed.xMax3 and y < GameSpeed.yMin3 and y > GameSpeed.yMax3 then
				Spring.SendCommands({"slowdown"})
			end			
		end
	end
end

function widget:Initialize()

	local sndVol =  tonumber(Spring.GetConfigString("snd_volmaster",1))	
	if sndVol < 30 then
		Spring.SetConfigString("snd_volmaster", (100)) 
	end
	Spring.SendCommands({"unbind esc quitmenu"})

	local viewX, viewY = gl.GetViewSizes()
	xGuideHelp = viewX
	yGuideHelp = viewY
  	xMinGuideHelp = xGuideHelp * (0.34) -- (800 - 256) / 1600
  	xMaxGuideHelp = xGuideHelp * (0.66) -- (800 + 256) /1600
  	yMinGuideHelp = yGuideHelp * (0.286667) -- (600 - 256) / 1200      -NOTE:  Main UI is 512 pixels high!
  	yMaxGuideHelp = yGuideHelp * (0.713333) -- (600 + 256) / 1200

	GroundDetail = {	
			xMin1 = 286 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMin1 = yMaxGuideHelp - (47 * (yGuideHelp / 1200)),
			xMax1 =338 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMax1 = yMaxGuideHelp - (62 * (yGuideHelp / 1200)),

			xMin2 = 351 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMin2 = yMaxGuideHelp - (47 * (yGuideHelp / 1200)),
			xMax2 = 403 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMax2 = yMaxGuideHelp - (62 * (yGuideHelp / 1200)),
			}

	Shadows = {			
			xMin1 = 286 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMin1 = yMaxGuideHelp - (64 * (yGuideHelp / 1200)),
			xMax1 = 323 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMax1 = yMaxGuideHelp - (81 * (yGuideHelp / 1200)),

			xMin2 = 335 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMin2 = yMaxGuideHelp - (64 * (yGuideHelp / 1200)),
			xMax2 = 384 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMax2 = yMaxGuideHelp - (81 * (yGuideHelp / 1200)),
		}

	WaterDetail = {
			xMin1 = 286 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMin1 = yMaxGuideHelp - (83 * (yGuideHelp / 1200)),
			xMax1 = 338 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMax1 = yMaxGuideHelp - (98 * (yGuideHelp / 1200)),

			xMin2 = 351 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMin2 = yMaxGuideHelp - (83 * (yGuideHelp / 1200)),
			xMax2 = 403 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMax2 = yMaxGuideHelp - (98 * (yGuideHelp / 1200)),

			xMin3 = 415 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMin3 = yMaxGuideHelp - (83 * (yGuideHelp / 1200)),
			xMax3 = 477 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMax3 = yMaxGuideHelp - (98 * (yGuideHelp / 1200)),
			}

	Music = {
			xMin1 = 299 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMin1 = yMaxGuideHelp - (146 * (yGuideHelp / 1200)),
			xMax1 = 338 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMax1 = yMaxGuideHelp - (161 * (yGuideHelp / 1200)),

			xMin2 = 349 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMin2 = yMaxGuideHelp - (146 * (yGuideHelp / 1200)),
			xMax2 = 398 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMax2 = yMaxGuideHelp - (161 * (yGuideHelp / 1200)),
			}

	MainVolume = {
			xMin1 = 299 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMin1 = yMaxGuideHelp - (166 * (yGuideHelp / 1200)),
			xMax1 = 349 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMax1 = yMaxGuideHelp - (180 * (yGuideHelp / 1200)),

			xMin2 = 360 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMin2 = yMaxGuideHelp - (166 * (yGuideHelp / 1200)),
			xMax2 = 414 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMax2 = yMaxGuideHelp - (180 * (yGuideHelp / 1200)),

			xMin3 = 427 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMin3 = yMaxGuideHelp - (166 * (yGuideHelp / 1200)),
			xMax3 = 487 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMax3 = yMaxGuideHelp - (180 * (yGuideHelp / 1200)),
			}

	ReplyVolume = {
			xMin1 = 299 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMin1 = yMaxGuideHelp - (183 * (yGuideHelp / 1200)),
			xMax1 = 352 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMax1 = yMaxGuideHelp - (196 * (yGuideHelp / 1200)),

			xMin2 = 364 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMin2 = yMaxGuideHelp - (183 * (yGuideHelp / 1200)),
			xMax2 = 417 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMax2 = yMaxGuideHelp - (196 * (yGuideHelp / 1200)),

			xMin3 = 429 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMin3 = yMaxGuideHelp - (183 * (yGuideHelp / 1200)),
			xMax3 = 490 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMax3 = yMaxGuideHelp - (196 * (yGuideHelp / 1200)),
			}

	GameSpeed = {
			xMin1 = 0.51999998092651* viewX, 
			yMin1 = 0.49833333492279* viewY, 
			xMax1 = 0.56999999284744* viewX, 
			yMax1 = 0.48750001192093* viewY,

			xMin2 = 0.57749998569489* viewX, 
			yMin2 = 0.49833333492279* viewY, 
			xMax2 = 0.59687501192093* viewX, 
			yMax2 = 0.48750001192093* viewY,

			xMin3 = 0.60562497377396* viewX, 
			yMin3 = 0.49833333492279* viewY, 
			xMax3 = 0.64999997615814* viewX, 
			yMax3 = 0.48750001192093* viewY,
			}

	CameraMode = {
			xMin1 = 0.37187498807907* viewX, 
			yMin1 = 0.46500000357628* viewY, 
			xMax1 = 0.45562499761581* viewX, 
			yMax1 = 0.44999998807907* viewY,

			xMin2 = 0.46187499165535* viewX, 
			yMin2 = 0.46500000357628* viewY, 
			xMax2 = 0.54187500476837* viewX, 
			yMax2 = 0.44999998807907* viewY,

			xMin3 = 0.546875* viewX, 
			yMin3 = 0.46500000357628* viewY, 
			xMax3 = 0.6231250166893* viewX, 
			yMax3 = 0.44999998807907* viewY,
			}

	ViewFPS = {
			xMin1 = 0.46687498688698* viewX, 
			yMin1 = 0.37250000238419* viewY, 
			xMax1 = 0.49500000476837* viewX, 
			yMax1 = 0.36083334684372* viewY,

			xMin2 = 0.50125002861023* viewX, 
			yMin2 = 0.37250000238419* viewY, 
			xMax2 = 0.53* viewX, 
			yMax2 = 0.36083334684372* viewY,
			}

	UnitDistance = {
			xMin1 = 0.41874998807907* viewX, 
			yMin1 = 0.43333333730698* viewY, 
			xMax1 = 0.47124999761581* viewX, 
			yMax1 = 0.42083331942558* viewY,

			xMin2 = 0.47749999165535* viewX, 
			yMin2 = 0.43333333730698* viewY, 
			xMax2 = 0.54* viewX, 
			yMax2 = 0.42083331942558* viewY,

			xMin3 = 0.5450000166893* viewX, 
			yMin3 = 0.43333333730698* viewY, 
			xMax3 = 0.57499998807907* viewX, 
			yMax3 = 0.42083331942558* viewY,
		}

	myParticleCount = {
			xMin1 = 0.40625* viewX, 
			yMin1 = 0.40416666865349* viewY, 
			xMax1 = 0.46062499284744* viewX, 
			yMax1 = 0.39166668057442* viewY,

			xMin2 = 0.46562498807907* viewX, 
			yMin2 = 0.40416666865349* viewY, 
			xMax2 = 0.5293750166893* viewX, 
			yMax2 = 0.39166668057442* viewY,
			
			xMin3 = 0.53437501192093* viewX, 
			yMin3 = 0.40416666865349* viewY,  
			xMax3 = 0.585* viewX, 
			yMax3 = 0.39166668057442* viewY,
			}

	QuitBox = {
			xMin1 = 121 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMin1 = yMaxGuideHelp - (460 * (yGuideHelp / 1200)),
			xMax1 = 398 * (xGuideHelp / 1600) + xMinGuideHelp,
			yMax1 = yMaxGuideHelp - (486 * (yGuideHelp / 1200)),
			}

	OptionsStatic = {
			xMin1 = viewX * (0.92),
			yMin1 = viewY * (0.973333),			
			xMax1 = viewX,
			yMax1 = viewY,
			}

	myExitOptions = {
			xMin1 = 0.39625000953674* viewX, 
			yMin1 = 0.35249999165535* viewY, 
			xMax1 = 0.61437499523163* viewX, 
			yMax1 = 0.32833334803581* viewY,
			}

	local settingState =  tonumber(Spring.GetConfigString("ShowFPS",1))
	if settingState == 1 then
		ViewFPSState = 1
	else
		ViewFPSState = 0
	end

	settingState =  tonumber(Spring.GetConfigString("UnitLodDist",1))
	if settingState <= 300 then
		UnitDistanceState = 1
	end
	if settingState > 300 and settingState < 501 then
		UnitDistanceState = 2
	end
	if settingState > 501 then
		UnitDistanceState = 3
	end

	settingState =  tonumber(Spring.GetConfigString("MaxParticles",1))
	if settingState <= 500 then
		myParticleCountState = 1
	end
	if settingState > 500 and settingState < 5000 then
		myParticleCountState = 2
	end
	if settingState > 5000 then
		myParticleCountState = 3
	end

	settingState =  tonumber(Spring.GetConfigString("Shadows",1))
	if settingState == 0 then
		ShadowsState = 0
	else
		ShadowState = 1
	end

	settingState = Spring.GetWaterMode()
	Spring.Echo("Watermode is "..settingState)
	if string.find(settingState,"0") then
		WaterDetailState = 0
	end
	if string.find(settingState,"1") then
		WaterDetailState = 1
	end
	if string.find(settingState,"2") then
		WaterDetailState = 2
	end
	if string.find(settingState,"3") then
		WaterDetailState = 3
	end
	if settingState == "4" then
		WaterDetailState = 4
	end

	for name,data in pairs(widgetHandler.widgets) do
      		if data.whInfo.name == "Theme" then
        			settingState = data.whInfo.enabled
			if settingState == true then
				MusicState = 1
			end
			if settingState == false then
				MusicState = 0
			end
      		end
	end

	settingState =  tonumber(Spring.GetConfigString("snd_volunitreply",1))
	if settingState <= 80 then
		ReplyVolumeState = 1
	end
	if settingState > 80 and settingState <= 90 then
		ReplyVolumeState = 2
	end
	if settingState >= 91 then
		ReplyVolumeState = 3
	end

	settingState =  tonumber(Spring.GetConfigString("snd_volbattle",1))
	if settingState <= 80 then
		MainVolumeState = 1
	end
	if settingState > 80 and settingState <= 90 then
		MainVolumeState = 2
	end
	if settingState >= 91 then
		MainVolumeState = 3
	end

	startDrawing = 1
end

function widget:KeyPress(key, mods, isRepeat)
	 if (key == KEYSYMS.ESCAPE) then
		if optionsOpen == 1 then 
			optionsOpen = 0
		else 
			optionsOpen = 1
		end
	end
end

function widget:DrawScreenEffects()
--Spring.Echo(OptionsStatic.xMin1,OptionsStatic.xMax1,OptionsStatic.yMin1,OptionsStatic.xMax1)

	if startDrawing == 1 then
		--OPTIONS BUTTON
		glTexture(OptionsStaticTexture)
		glColor(1,1,1,1)
		glTexRect(OptionsStatic.xMin1,OptionsStatic.yMin1,OptionsStatic.xMax1,OptionsStatic.yMax1)

		--glTexRect(myExitOptions.xMin1,myExitOptions.yMin1,myExitOptions.xMax1,myExitOptions.yMax1)
	end

	if optionsOpen == 1 then
	--NO TEXTURE	
	glTexture(false)

	
		--Spring.Echo(GroundDetail.xMin1,GroundDetail.yMin1,GroundDetail.xMax1,GroundDetail.yMax1)
		--BACKDROP
		glTexture(currentTexture)
		glColor(1,1,1,1)
		glTexRect(xMinGuideHelp,yMinGuideHelp,xMaxGuideHelp,yMaxGuideHelp)
	
		--NO TEXTURE
		glTexture(false)
		--SHADOWS
		if ShadowState == 1 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(Shadows.xMin1,Shadows.yMin1,Shadows.xMax1,Shadows.yMax1)
		if ShadowState == 0 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(Shadows.xMin2,Shadows.yMin2,Shadows.xMax2,Shadows.yMax2)
		
		--WATER
		if WaterDetailState == 0 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(WaterDetail.xMin1,WaterDetail.yMin1,WaterDetail.xMax1,WaterDetail.yMax1)
		if WaterDetailState == 3 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(WaterDetail.xMin2,WaterDetail.yMin2,WaterDetail.xMax2,WaterDetail.yMax2)
		if WaterDetailState == 4 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(WaterDetail.xMin3,WaterDetail.yMin3,WaterDetail.xMax3,WaterDetail.yMax3)

		--MUSIC
		if MusicState == 1 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(Music.xMin1,Music.yMin1,Music.xMax1,Music.yMax1)
		if MusicState == 0 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(Music.xMin2,Music.yMin2,Music.xMax2,Music.yMax2)

		--MAIN VOLUME
		if MainVolumeState == 1 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(MainVolume.xMin1,MainVolume.yMin1,MainVolume.xMax1,MainVolume.yMax1)
		if MainVolumeState == 2 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(MainVolume.xMin2,MainVolume.yMin2,MainVolume.xMax2,MainVolume.yMax2)
		if MainVolumeState == 3 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(MainVolume.xMin3,MainVolume.yMin3,MainVolume.xMax3,MainVolume.yMax3)

		--REPLY VOLUME
		if ReplyVolumeState == 1 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(ReplyVolume.xMin1,ReplyVolume.yMin1,ReplyVolume.xMax1,ReplyVolume.yMax1)
		if ReplyVolumeState == 2 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(ReplyVolume.xMin2,ReplyVolume.yMin2,ReplyVolume.xMax2,ReplyVolume.yMax2)
		if ReplyVolumeState == 3 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(ReplyVolume.xMin3,ReplyVolume.yMin3,ReplyVolume.xMax3,ReplyVolume.yMax3)

		--PARTICLE COUNT
		if myParticleCountState == 1 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(myParticleCount.xMin1,myParticleCount.yMin1,myParticleCount.xMax1,myParticleCount.yMax1)
		if myParticleCountState == 2 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(myParticleCount.xMin2,myParticleCount.yMin2,myParticleCount.xMax2,myParticleCount.yMax2)
		if myParticleCountState == 3 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(myParticleCount.xMin3,myParticleCount.yMin3,myParticleCount.xMax3,myParticleCount.yMax3)

		--FPS STATE
		if ViewFPSState == 1 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(ViewFPS.xMin1,ViewFPS.yMin1,ViewFPS.xMax1,ViewFPS.yMax1)
		if ViewFPSState == 0 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(ViewFPS.xMin2,ViewFPS.yMin2,ViewFPS.xMax2,ViewFPS.yMax2)

		--UNIT DISTANCE
		if UnitDistanceState == 1 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(UnitDistance.xMin1,UnitDistance.yMin1,UnitDistance.xMax1,UnitDistance.yMax1)
		if UnitDistanceState == 2 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(UnitDistance.xMin2,UnitDistance.yMin2,UnitDistance.xMax2,UnitDistance.yMax2)
		if UnitDistanceState == 3 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(UnitDistance.xMin3,UnitDistance.yMin3,UnitDistance.xMax3,UnitDistance.yMax3)

		--CAMERA MODE
		if CameraModeState == 1 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(CameraMode.xMin1,CameraMode.yMin1,CameraMode.xMax1,CameraMode.yMax1)
		if CameraModeState == 2 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(CameraMode.xMin2,CameraMode.yMin2,CameraMode.xMax2,CameraMode.yMax2)
		if CameraModeState == 3 then glColor(0,1,0,0.5) else glColor(1,0,0,0.5) end
		gl.Rect(CameraMode.xMin3,CameraMode.yMin3,CameraMode.xMax3,CameraMode.yMax3)
	end
end